﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using EJ2Grid.Models;
using Syncfusion.EJ2.Base;
using System.Collections;
using System.ComponentModel.DataAnnotations;

namespace EJ2Grid.Controllers
{
    public class HomeController : Controller
    {
        public static List<Orders> order = new List<Orders>();
        public static List<EmployeeDetails> emplyees = new List<EmployeeDetails>();
        public IActionResult Index()
        {
            ViewBag.DataSource = Orders.getAllRecords();
            return View();
        }

        public IActionResult UrlDatasource([FromBody] DataManagerRequest dm)
        {
            IEnumerable DataSource = EmployeeDetails.getAllRecords();
            DataOperations operation = new DataOperations();
            if (dm.Search != null && dm.Search.Count > 0)
            {
                DataSource = operation.PerformSearching(DataSource, dm.Search);  //Search
            }
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                DataSource = operation.PerformSorting(DataSource, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                DataSource = operation.PerformFiltering(DataSource, dm.Where, dm.Where[0].Operator);
            }
            int count = DataSource.Cast<EmployeeDetails>().Count();
            if (dm.Skip != 0)
            {
                DataSource = operation.PerformSkip(DataSource, dm.Skip);   //Paging
            }
            if (dm.Take != 0)
            {
                DataSource = operation.PerformTake(DataSource, dm.Take);
            }
            return dm.RequiresCounts ? Json(new { result = DataSource, count = count }) : Json(DataSource);
        }

        public IActionResult ChildUrlDatasource([FromBody] DataManagerRequest dm)
        {
            IEnumerable DataSource = Orders.getAllRecords();
            DataOperations operation = new DataOperations();
            if (dm.Search != null && dm.Search.Count > 0)
            {
                DataSource = operation.PerformSearching(DataSource, dm.Search);  //Search
            }
            if (dm.Sorted != null && dm.Sorted.Count > 0) //Sorting
            {
                DataSource = operation.PerformSorting(DataSource, dm.Sorted);
            }
            if (dm.Where != null && dm.Where.Count > 0) //Filtering
            {
                DataSource = operation.PerformFiltering(DataSource, dm.Where, dm.Where[0].Operator);
            }
            int count = DataSource.Cast<Orders>().Count();
            if (dm.Skip != 0)
            {
                DataSource = operation.PerformSkip(DataSource, dm.Skip);   //Paging
            }
            if (dm.Take != 0)
            {
                DataSource = operation.PerformTake(DataSource, dm.Take);
            }
            return dm.RequiresCounts ? Json(new { result = DataSource, count = count }) : Json(DataSource);
        }


        public IActionResult Insert([FromBody] CRUDModel<EmployeeDetails> value)
        {
            emplyees.Insert(0, value.value);
            return Json(value.value);
        }


        public IActionResult ChildInsert([FromBody] CRUDModel<Orders> value)
        {
            order.Insert(0, value.value);
            return Json(value.value);
        }

        //public ActionResult BatchUpdate([FromBody]CRUDModel batchmodel)
        //{
        //    if (batchmodel.Changed != null)
        //    {
        //        for (var i = 0; i < batchmodel.Changed.Count(); i++)
        //        {

        //            var ord = batchmodel.Changed[i];
        //            Orders val = Orders.getAllRecords().Where(or => or.OrderID == ord.OrderID).FirstOrDefault();
        //            val.OrderID = ord.OrderID;
        //            val.EmployeeID = ord.EmployeeID;
        //            val.CustomerID = ord.CustomerID;
        //            val.CustomerName = ord.CustomerName;
        //            val.Freight = ord.Freight;
        //            val.OrderDate = ord.OrderDate;
        //            val.ShipCity = ord.ShipCity;
        //            val.ShipCountry = ord.ShipCountry;
        //        }
        //    }

        //    if (batchmodel.Deleted != null)
        //    {
        //        for (var i = 0; i < batchmodel.Deleted.Count(); i++)
        //        {
        //            Orders.getAllRecords().Remove(Orders.getAllRecords().Where(or => or.OrderID == batchmodel.Deleted[i].OrderID).FirstOrDefault());
        //        }
        //    }

        //    if (batchmodel.Added != null)
        //    {
        //        for (var i = 0; i < batchmodel.Added.Count(); i++)
        //        {
        //            Orders.getAllRecords().Insert(0, batchmodel.Added[i]);
        //        }
        //    }
        //    var data = Orders.getAllRecords().ToList();
        //    return Json(data);

        //}

        public IActionResult Update([FromBody] CRUDModel<EmployeeDetails> model)
        {
            var data = emplyees.Where(emp => emp.EmployeeID == model.value.EmployeeID).FirstOrDefault();
            if (data != null)
            {
                data.EmployeeID = model.value.EmployeeID;
                data.FirstName = model.value.FirstName;
                data.Title = model.value.Title;
                data.UseFirstName = model.value.UseFirstName;
                data.UseTitle = model.value.UseTitle;
                data.NewData = model.value.NewData;
            }
            return Json(model.value);
        }


        public IActionResult ChildUpdate([FromBody] CRUDModel<Orders> model)
        {
            var data = order.Where(or => or.OrderID == model.value.OrderID).FirstOrDefault();
            if (data != null)
            {
                data.OrderID = model.value.OrderID;
                data.CustomerID = model.value.CustomerID;
                data.ShipCity = model.value.ShipCity;
                data.Freight = model.value.Freight;
                data.ShipName = model.value.ShipName;
            }
            return Json(model.value);
        }

        public void Remove([FromBody] CRUDModel<EmployeeDetails> Value)
        {
            var data = emplyees.Where(emp => emp.EmployeeID.Equals(Value.key)).FirstOrDefault();
            emplyees.Remove(data);
        }


        public void ChildRemove([FromBody] CRUDModel<Orders> Value)
        {
            var data = order.Where(or => or.OrderID.Equals(Value.key)).FirstOrDefault();
            order.Remove(data);
        }
        public class CRUDModel<T> where T : class
        {
            public string action { get; set; }

            public string table { get; set; }

            public string keyColumn { get; set; }

            public object key { get; set; }

            public T value { get; set; }

            public List<T> added { get; set; }

            public List<T> changed { get; set; }

            public List<T> deleted { get; set; }

            public IDictionary<string, object> @params { get; set; }
        }

        public class Orders
        {
            public Orders()
            {

            }
            public Orders(long OrderID, string CustomerID, double Freight, string ShipName, string ShipAddress, string ShipCity, string ShipRegion, string ShipCountry, string CustomerName)
            {
                this.OrderID = OrderID;
                this.CustomerID = CustomerID;
                this.Freight = Freight;
                this.ShipName = ShipName;
                this.ShipAddress = ShipAddress;
                this.ShipCity = ShipCity;
                this.ShipRegion = ShipRegion;
                this.ShipCountry = ShipCountry;
                this.CustomerName = CustomerName;
            }

            public static List<Orders> getAllRecords()
            {
                if (order.Count == 0)
                {
                    order.Add(new Orders(10260, "OTTIK", 55.09, "Ottilies Käseladen", "Mehrheimerstr. 369", "Köln", null, "Germany", "Henriette Pfalzheim"));
                    order.Add(new Orders(10261, "QUEDE", 3.05, "Que Delícia", "Rua da Panificadora, 12", "Rio de Janeiro", "RJ", "Brazil", "Bernardo Batista"));
                    order.Add(new Orders(10262, "RATTC", 48.29, "Rattlesnake Canyon Grocery", "2817 Milton Dr.", "Albuquerque", "NM", "USA", "Paula Wilson"));
                    order.Add(new Orders(10263, "ERNSH", 146.06, "Ernst Handel", "Kirchgasse 6", "Graz", null, "Austria", "Roland Mendel"));
                    order.Add(new Orders(10264, "FOLKO", 3.67, "Folk och fä HB", "Åkergatan 24", "Bräcke", null, "Sweden", "Maria Larsson"));
                    order.Add(new Orders(10265, "BLONP", 55.28, "Blondel père et fils", "24, place Kléber", "Strasbourg", null, "France", "Frédérique Citeaux"));
                    order.Add(new Orders(10266, "WARTH", 25.73, "Wartian Herkku", "Torikatu 38", "Oulu", null, "Finland", "Pirkko Koskitalo"));
                    order.Add(new Orders(10267, "FRANK", 208.58, "Frankenversand", "Berliner Platz 43", "München", null, "Germany", "Peter Franken"));
                    order.Add(new Orders(10268, "GROSR", 66.29, "GROSELLA-Restaurante", "5ª Ave. Los Palos Grandes", "Caracas", "DF", "Venezuela", "Manuel Pereira"));
                    order.Add(new Orders(10269, "WHITC", 4.56, "White Clover Markets", "1029 - 12th Ave. S.", "Seattle", "WA", "USA", "Karl Jablonski"));
                    order.Add(new Orders(10270, "WARTH", 136.54, "Wartian Herkku", "Torikatu 38", "Oulu", null, "Finland", "Pirkko Koskitalo"));
                    order.Add(new Orders(10271, "SPLIR", 4.54, "Split Rail Beer & Ale", "P.O. Box 555", "Lander", "WY", "USA", "Art Braunschweiger"));
                    order.Add(new Orders(10272, "RATTC", 98.03, "Rattlesnake Canyon Grocery", "2817 Milton Dr.", "Albuquerque", "NM", "USA", "Paula Wilson"));
                    order.Add(new Orders(10273, "QUICK", 76.07, "QUICK-Stop", "Taucherstraße 10", "Cunewalde", null, "Germany", "Horst Kloss"));
                    order.Add(new Orders(10274, "VINET",  6.01, "Vins et alcools Chevalier", "59 rue de l Abbaye", "Reims", null, "France", "Paul Henriot"));
                    order.Add(new Orders(10275, "MAGAA", 26.93, "Magazzini Alimentari Riuniti", "Via Ludovico il Moro 22", "Bergamo", null, "Italy", "Giovanni Rovelli"));
                }
                return order;
            }

            public long OrderID { get; set; }
            [Required]
            public string CustomerID { get; set; }
            public double Freight { get; set; }
            public string ShipName { get; set; }
            public string ShipAddress { get; set; }
            public string ShipCity { get; set; }
            public string ShipRegion { get; set; }
            public string ShipCountry { get; set; }
            public string CustomerName { get; set; }
        }

        public class EmployeeDetails
        {
            public EmployeeDetails()
            {

            }
            public EmployeeDetails(int EmployeeID,  string FirstName, bool UseFirstName, string Title, bool UseTitle, string NewData)
            {
                this.EmployeeID = EmployeeID;
                this.FirstName = FirstName;
                this.Title = Title;
                this.NewData = NewData;
                this.UseFirstName = UseFirstName;
                this.UseTitle = UseTitle;
            }

            public static List<EmployeeDetails> getAllRecords()
            {
                if (emplyees.Count == 0)
                {
                    emplyees.Add(new EmployeeDetails(1, "Nancy", false, "Sales Representative", false, ""));
                    emplyees.Add(new EmployeeDetails(2, "Andrew", false, "Vice President", false, ""));
                    emplyees.Add(new EmployeeDetails(3, "Janet", false, "Sales Representative", false, ""));
                        
                }
                return emplyees;
            }

            public int EmployeeID { get; set; }
            [Required]
            public string FirstName { get; set; }
            public bool UseFirstName { get; set; }
            public string Title { get; set; }
            public bool UseTitle { get; set; }
            public string NewData { get; set; }
        }
    }
}
